"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.router = exports.Router = void 0;
const history_1 = require("history");
class Router {
    constructor(options) {
        this.options = options;
    }
    get history() {
        var _a, _b;
        if (this._history)
            return this._history;
        if ((_a = this.options) === null || _a === void 0 ? void 0 : _a.history) {
            this._history = (_b = this.options) === null || _b === void 0 ? void 0 : _b.history;
        }
        else if (window.__doreamonjs.history) {
            // doreamonjs
            this._history = window.__doreamonjs.history;
        }
        else if (window.g_history) {
            // umi
            this._history = window.g_history;
        }
        else {
            this._history = history_1.createBrowserHistory();
        }
        return this._history;
    }
    push(path, state) {
        this.history.push(path, state);
    }
    replace(path, state) {
        this.history.replace(path, state);
    }
    go(count) {
        this.history.go(count);
    }
    goBack() {
        this.history.back();
    }
}
exports.Router = Router;
exports.router = new Router();
